#include "load_ExtremePhysics.h"
#include <windows.h>

HINSTANCE handle_ExtremePhysics;

template<typename FP>
void load_from_ExtremePhysics(FP& fp, const char* name) {
	fp = (FP)(GetProcAddress(handle_ExtremePhysics, name));
	if(fp == NULL) {
		throw "Loading DLL function failed!";
	}
}

void load_ExtremePhysics() {
	
	handle_ExtremePhysics = LoadLibrary("ExtremePhysics.dll");
	if(handle_ExtremePhysics == NULL) {
		throw "Loading DLL failed!";
	}
	
	load_from_ExtremePhysics(ep_version, "ep_version");
	load_from_ExtremePhysics(ep_set_log_file, "ep_set_log_file");
	load_from_ExtremePhysics(ep_set_show_errors, "ep_set_show_errors");
	load_from_ExtremePhysics(ep_message, "ep_message");
	load_from_ExtremePhysics(ep_print_object_tree, "ep_print_object_tree");
	load_from_ExtremePhysics(ep_collision_test_box_box, "ep_collision_test_box_box");
	load_from_ExtremePhysics(ep_collision_test_box_line, "ep_collision_test_box_line");
	load_from_ExtremePhysics(ep_collision_test_box_circle, "ep_collision_test_box_circle");
	load_from_ExtremePhysics(ep_collision_test_box_polygon, "ep_collision_test_box_polygon");
	load_from_ExtremePhysics(ep_collision_test_line_line, "ep_collision_test_line_line");
	load_from_ExtremePhysics(ep_collision_test_line_circle, "ep_collision_test_line_circle");
	load_from_ExtremePhysics(ep_collision_test_line_polygon, "ep_collision_test_line_polygon");
	load_from_ExtremePhysics(ep_collision_test_circle_circle, "ep_collision_test_circle_circle");
	load_from_ExtremePhysics(ep_collision_test_circle_polygon, "ep_collision_test_circle_polygon");
	load_from_ExtremePhysics(ep_collision_test_polygon_polygon, "ep_collision_test_polygon_polygon");
	load_from_ExtremePhysics(ep_ray_cast_box, "ep_ray_cast_box");
	load_from_ExtremePhysics(ep_ray_cast_line, "ep_ray_cast_line");
	load_from_ExtremePhysics(ep_ray_cast_circle, "ep_ray_cast_circle");
	load_from_ExtremePhysics(ep_ray_cast_polygon, "ep_ray_cast_polygon");
	load_from_ExtremePhysics(ep_first_world, "ep_first_world");
	load_from_ExtremePhysics(ep_last_world, "ep_last_world");
	load_from_ExtremePhysics(ep_gm_functions_init, "ep_gm_functions_init");
	load_from_ExtremePhysics(ep_gm_functions_init_address, "ep_gm_functions_init_address");
	load_from_ExtremePhysics(ep_debugdraw_set_transformation, "ep_debugdraw_set_transformation");
	load_from_ExtremePhysics(ep_debugdraw_bodies, "ep_debugdraw_bodies");
	load_from_ExtremePhysics(ep_debugdraw_links, "ep_debugdraw_links");
	load_from_ExtremePhysics(ep_debugdraw_views, "ep_debugdraw_views");
	load_from_ExtremePhysics(ep_debugdraw_velocity, "ep_debugdraw_velocity");
	load_from_ExtremePhysics(ep_debugdraw_forces, "ep_debugdraw_forces");
	load_from_ExtremePhysics(ep_debugdraw_constraints, "ep_debugdraw_constraints");
	load_from_ExtremePhysics(ep_world_create, "ep_world_create");
	load_from_ExtremePhysics(ep_world_destroy, "ep_world_destroy");
	load_from_ExtremePhysics(ep_world_exists, "ep_world_exists");
	load_from_ExtremePhysics(ep_world_clear, "ep_world_clear");
	load_from_ExtremePhysics(ep_world_set_settings, "ep_world_set_settings");
	load_from_ExtremePhysics(ep_world_set_primary_axis, "ep_world_set_primary_axis");
	load_from_ExtremePhysics(ep_world_set_sleeping, "ep_world_set_sleeping");
	load_from_ExtremePhysics(ep_world_update_contacts, "ep_world_update_contacts");
	load_from_ExtremePhysics(ep_world_simulate_step, "ep_world_simulate_step");
	load_from_ExtremePhysics(ep_world_collision_test_box, "ep_world_collision_test_box");
	load_from_ExtremePhysics(ep_world_collision_test_line, "ep_world_collision_test_line");
	load_from_ExtremePhysics(ep_world_collision_test_circle, "ep_world_collision_test_circle");
	load_from_ExtremePhysics(ep_world_collision_test_polygon, "ep_world_collision_test_polygon");
	load_from_ExtremePhysics(ep_world_ray_cast, "ep_world_ray_cast");
	load_from_ExtremePhysics(ep_world_get_collision_body, "ep_world_get_collision_body");
	load_from_ExtremePhysics(ep_world_get_collision_shape, "ep_world_get_collision_shape");
	load_from_ExtremePhysics(ep_world_multipoly_begin, "ep_world_multipoly_begin");
	load_from_ExtremePhysics(ep_world_multipoly_end, "ep_world_multipoly_end");
	load_from_ExtremePhysics(ep_world_multipoly_set_vertex, "ep_world_multipoly_set_vertex");
	load_from_ExtremePhysics(ep_world_multipoly_get_first, "ep_world_multipoly_get_first");
	load_from_ExtremePhysics(ep_world_multipoly_get_last, "ep_world_multipoly_get_last");
	load_from_ExtremePhysics(ep_world_serialize, "ep_world_serialize");
	load_from_ExtremePhysics(ep_world_unserialize, "ep_world_unserialize");
	load_from_ExtremePhysics(ep_world_previous, "ep_world_previous");
	load_from_ExtremePhysics(ep_world_next, "ep_world_next");
	load_from_ExtremePhysics(ep_world_set_uservar, "ep_world_set_uservar");
	load_from_ExtremePhysics(ep_world_get_uservar, "ep_world_get_uservar");
	load_from_ExtremePhysics(ep_world_first_polygon, "ep_world_first_polygon");
	load_from_ExtremePhysics(ep_world_last_polygon, "ep_world_last_polygon");
	load_from_ExtremePhysics(ep_world_polygon_count, "ep_world_polygon_count");
	load_from_ExtremePhysics(ep_world_first_body, "ep_world_first_body");
	load_from_ExtremePhysics(ep_world_last_body, "ep_world_last_body");
	load_from_ExtremePhysics(ep_world_body_count, "ep_world_body_count");
	load_from_ExtremePhysics(ep_world_first_contact, "ep_world_first_contact");
	load_from_ExtremePhysics(ep_world_last_contact, "ep_world_last_contact");
	load_from_ExtremePhysics(ep_world_contact_count, "ep_world_contact_count");
	load_from_ExtremePhysics(ep_world_first_hingejoint, "ep_world_first_hingejoint");
	load_from_ExtremePhysics(ep_world_last_hingejoint, "ep_world_last_hingejoint");
	load_from_ExtremePhysics(ep_world_hingejoint_count, "ep_world_hingejoint_count");
	load_from_ExtremePhysics(ep_world_first_distancejoint, "ep_world_first_distancejoint");
	load_from_ExtremePhysics(ep_world_last_distancejoint, "ep_world_last_distancejoint");
	load_from_ExtremePhysics(ep_world_distancejoint_count, "ep_world_distancejoint_count");
	load_from_ExtremePhysics(ep_world_first_railjoint, "ep_world_first_railjoint");
	load_from_ExtremePhysics(ep_world_last_railjoint, "ep_world_last_railjoint");
	load_from_ExtremePhysics(ep_world_railjoint_count, "ep_world_railjoint_count");
	load_from_ExtremePhysics(ep_world_first_sliderjoint, "ep_world_first_sliderjoint");
	load_from_ExtremePhysics(ep_world_last_sliderjoint, "ep_world_last_sliderjoint");
	load_from_ExtremePhysics(ep_world_sliderjoint_count, "ep_world_sliderjoint_count");
	load_from_ExtremePhysics(ep_world_first_view, "ep_world_first_view");
	load_from_ExtremePhysics(ep_world_last_view, "ep_world_last_view");
	load_from_ExtremePhysics(ep_world_view_count, "ep_world_view_count");
	load_from_ExtremePhysics(ep_world_first_water, "ep_world_first_water");
	load_from_ExtremePhysics(ep_world_last_water, "ep_world_last_water");
	load_from_ExtremePhysics(ep_world_water_count, "ep_world_water_count");
	load_from_ExtremePhysics(ep_world_shape_count, "ep_world_shape_count");
	load_from_ExtremePhysics(ep_world_force_count, "ep_world_force_count");
	load_from_ExtremePhysics(ep_polygon_create, "ep_polygon_create");
	load_from_ExtremePhysics(ep_polygon_destroy, "ep_polygon_destroy");
	load_from_ExtremePhysics(ep_polygon_exists, "ep_polygon_exists");
	load_from_ExtremePhysics(ep_polygon_set_vertex, "ep_polygon_set_vertex");
	load_from_ExtremePhysics(ep_polygon_initialize, "ep_polygon_initialize");
	load_from_ExtremePhysics(ep_polygon_get_vertex_count, "ep_polygon_get_vertex_count");
	load_from_ExtremePhysics(ep_polygon_get_vertex_x, "ep_polygon_get_vertex_x");
	load_from_ExtremePhysics(ep_polygon_get_vertex_y, "ep_polygon_get_vertex_y");
	load_from_ExtremePhysics(ep_polygon_get_vertex_normal_x, "ep_polygon_get_vertex_normal_x");
	load_from_ExtremePhysics(ep_polygon_get_vertex_normal_y, "ep_polygon_get_vertex_normal_y");
	load_from_ExtremePhysics(ep_polygon_get_edge_length, "ep_polygon_get_edge_length");
	load_from_ExtremePhysics(ep_polygon_previous, "ep_polygon_previous");
	load_from_ExtremePhysics(ep_polygon_next, "ep_polygon_next");
	load_from_ExtremePhysics(ep_polygon_set_uservar, "ep_polygon_set_uservar");
	load_from_ExtremePhysics(ep_polygon_get_uservar, "ep_polygon_get_uservar");
	load_from_ExtremePhysics(ep_body_create_static, "ep_body_create_static");
	load_from_ExtremePhysics(ep_body_create_dynamic, "ep_body_create_dynamic");
	load_from_ExtremePhysics(ep_body_destroy, "ep_body_destroy");
	load_from_ExtremePhysics(ep_body_exists, "ep_body_exists");
	load_from_ExtremePhysics(ep_body_get_first_hingejoint, "ep_body_get_first_hingejoint");
	load_from_ExtremePhysics(ep_body_get_last_hingejoint, "ep_body_get_last_hingejoint");
	load_from_ExtremePhysics(ep_body_get_previous_hingejoint, "ep_body_get_previous_hingejoint");
	load_from_ExtremePhysics(ep_body_get_next_hingejoint, "ep_body_get_next_hingejoint");
	load_from_ExtremePhysics(ep_body_get_first_distancejoint, "ep_body_get_first_distancejoint");
	load_from_ExtremePhysics(ep_body_get_last_distancejoint, "ep_body_get_last_distancejoint");
	load_from_ExtremePhysics(ep_body_get_previous_distancejoint, "ep_body_get_previous_distancejoint");
	load_from_ExtremePhysics(ep_body_get_next_distancejoint, "ep_body_get_next_distancejoint");
	load_from_ExtremePhysics(ep_body_get_first_railjoint, "ep_body_get_first_railjoint");
	load_from_ExtremePhysics(ep_body_get_last_railjoint, "ep_body_get_last_railjoint");
	load_from_ExtremePhysics(ep_body_get_previous_railjoint, "ep_body_get_previous_railjoint");
	load_from_ExtremePhysics(ep_body_get_next_railjoint, "ep_body_get_next_railjoint");
	load_from_ExtremePhysics(ep_body_get_first_sliderjoint, "ep_body_get_first_sliderjoint");
	load_from_ExtremePhysics(ep_body_get_last_sliderjoint, "ep_body_get_last_sliderjoint");
	load_from_ExtremePhysics(ep_body_get_previous_sliderjoint, "ep_body_get_previous_sliderjoint");
	load_from_ExtremePhysics(ep_body_get_next_sliderjoint, "ep_body_get_next_sliderjoint");
	load_from_ExtremePhysics(ep_body_calculate_mass, "ep_body_calculate_mass");
	load_from_ExtremePhysics(ep_body_set_mass, "ep_body_set_mass");
	load_from_ExtremePhysics(ep_body_set_inertia, "ep_body_set_inertia");
	load_from_ExtremePhysics(ep_body_set_center, "ep_body_set_center");
	load_from_ExtremePhysics(ep_body_set_position, "ep_body_set_position");
	load_from_ExtremePhysics(ep_body_set_position_center, "ep_body_set_position_center");
	load_from_ExtremePhysics(ep_body_set_position_local_point, "ep_body_set_position_local_point");
	load_from_ExtremePhysics(ep_body_set_velocity_center, "ep_body_set_velocity_center");
	load_from_ExtremePhysics(ep_body_set_velocity_local_point, "ep_body_set_velocity_local_point");
	load_from_ExtremePhysics(ep_body_set_max_velocity, "ep_body_set_max_velocity");
	load_from_ExtremePhysics(ep_body_set_gravity, "ep_body_set_gravity");
	load_from_ExtremePhysics(ep_body_set_damping, "ep_body_set_damping");
	load_from_ExtremePhysics(ep_body_store_impulses, "ep_body_store_impulses");
	load_from_ExtremePhysics(ep_body_set_sleeping, "ep_body_set_sleeping");
	load_from_ExtremePhysics(ep_body_collision_test_box, "ep_body_collision_test_box");
	load_from_ExtremePhysics(ep_body_collision_test_line, "ep_body_collision_test_line");
	load_from_ExtremePhysics(ep_body_collision_test_circle, "ep_body_collision_test_circle");
	load_from_ExtremePhysics(ep_body_collision_test_polygon, "ep_body_collision_test_polygon");
	load_from_ExtremePhysics(ep_body_ray_cast, "ep_body_ray_cast");
	load_from_ExtremePhysics(ep_body_apply_impulse, "ep_body_apply_impulse");
	load_from_ExtremePhysics(ep_body_apply_impulse_relative, "ep_body_apply_impulse_relative");
	load_from_ExtremePhysics(ep_body_get_mass, "ep_body_get_mass");
	load_from_ExtremePhysics(ep_body_get_inertia, "ep_body_get_inertia");
	load_from_ExtremePhysics(ep_body_get_center_of_mass_x, "ep_body_get_center_of_mass_x");
	load_from_ExtremePhysics(ep_body_get_center_of_mass_y, "ep_body_get_center_of_mass_y");
	load_from_ExtremePhysics(ep_body_get_x, "ep_body_get_x");
	load_from_ExtremePhysics(ep_body_get_y, "ep_body_get_y");
	load_from_ExtremePhysics(ep_body_get_x_center, "ep_body_get_x_center");
	load_from_ExtremePhysics(ep_body_get_y_center, "ep_body_get_y_center");
	load_from_ExtremePhysics(ep_body_get_rot, "ep_body_get_rot");
	load_from_ExtremePhysics(ep_body_get_xvel_center, "ep_body_get_xvel_center");
	load_from_ExtremePhysics(ep_body_get_yvel_center, "ep_body_get_yvel_center");
	load_from_ExtremePhysics(ep_body_get_xvel_local_point, "ep_body_get_xvel_local_point");
	load_from_ExtremePhysics(ep_body_get_yvel_local_point, "ep_body_get_yvel_local_point");
	load_from_ExtremePhysics(ep_body_get_rotvel, "ep_body_get_rotvel");
	load_from_ExtremePhysics(ep_body_is_static, "ep_body_is_static");
	load_from_ExtremePhysics(ep_body_is_norotation, "ep_body_is_norotation");
	load_from_ExtremePhysics(ep_body_is_sleeping, "ep_body_is_sleeping");
	load_from_ExtremePhysics(ep_body_stable_timer, "ep_body_stable_timer");
	load_from_ExtremePhysics(ep_body_out_of_view_timer, "ep_body_out_of_view_timer");
	load_from_ExtremePhysics(ep_body_coord_local_to_world_x, "ep_body_coord_local_to_world_x");
	load_from_ExtremePhysics(ep_body_coord_local_to_world_y, "ep_body_coord_local_to_world_y");
	load_from_ExtremePhysics(ep_body_coord_world_to_local_x, "ep_body_coord_world_to_local_x");
	load_from_ExtremePhysics(ep_body_coord_world_to_local_y, "ep_body_coord_world_to_local_y");
	load_from_ExtremePhysics(ep_body_vect_local_to_world_x, "ep_body_vect_local_to_world_x");
	load_from_ExtremePhysics(ep_body_vect_local_to_world_y, "ep_body_vect_local_to_world_y");
	load_from_ExtremePhysics(ep_body_vect_world_to_local_x, "ep_body_vect_world_to_local_x");
	load_from_ExtremePhysics(ep_body_vect_world_to_local_y, "ep_body_vect_world_to_local_y");
	load_from_ExtremePhysics(ep_body_boxchain_begin, "ep_body_boxchain_begin");
	load_from_ExtremePhysics(ep_body_boxchain_end, "ep_body_boxchain_end");
	load_from_ExtremePhysics(ep_body_boxchain_set_vertex, "ep_body_boxchain_set_vertex");
	load_from_ExtremePhysics(ep_body_boxchain_get_first, "ep_body_boxchain_get_first");
	load_from_ExtremePhysics(ep_body_boxchain_get_last, "ep_body_boxchain_get_last");
	load_from_ExtremePhysics(ep_body_previous, "ep_body_previous");
	load_from_ExtremePhysics(ep_body_next, "ep_body_next");
	load_from_ExtremePhysics(ep_body_set_uservar, "ep_body_set_uservar");
	load_from_ExtremePhysics(ep_body_get_uservar, "ep_body_get_uservar");
	load_from_ExtremePhysics(ep_body_first_shape, "ep_body_first_shape");
	load_from_ExtremePhysics(ep_body_last_shape, "ep_body_last_shape");
	load_from_ExtremePhysics(ep_body_shape_count, "ep_body_shape_count");
	load_from_ExtremePhysics(ep_body_first_force, "ep_body_first_force");
	load_from_ExtremePhysics(ep_body_last_force, "ep_body_last_force");
	load_from_ExtremePhysics(ep_body_force_count, "ep_body_force_count");
	load_from_ExtremePhysics(ep_contact_destroy, "ep_contact_destroy");
	load_from_ExtremePhysics(ep_contact_exists, "ep_contact_exists");
	load_from_ExtremePhysics(ep_contact_get_body1, "ep_contact_get_body1");
	load_from_ExtremePhysics(ep_contact_get_body2, "ep_contact_get_body2");
	load_from_ExtremePhysics(ep_contact_get_shape1, "ep_contact_get_shape1");
	load_from_ExtremePhysics(ep_contact_get_shape2, "ep_contact_get_shape2");
	load_from_ExtremePhysics(ep_contact_get_normal_x, "ep_contact_get_normal_x");
	load_from_ExtremePhysics(ep_contact_get_normal_y, "ep_contact_get_normal_y");
	load_from_ExtremePhysics(ep_contact_get_point1_active, "ep_contact_get_point1_active");
	load_from_ExtremePhysics(ep_contact_get_point2_active, "ep_contact_get_point2_active");
	load_from_ExtremePhysics(ep_contact_get_point1_x, "ep_contact_get_point1_x");
	load_from_ExtremePhysics(ep_contact_get_point1_y, "ep_contact_get_point1_y");
	load_from_ExtremePhysics(ep_contact_get_point2_x, "ep_contact_get_point2_x");
	load_from_ExtremePhysics(ep_contact_get_point2_y, "ep_contact_get_point2_y");
	load_from_ExtremePhysics(ep_contact_get_point1_separation, "ep_contact_get_point1_separation");
	load_from_ExtremePhysics(ep_contact_get_point2_separation, "ep_contact_get_point2_separation");
	load_from_ExtremePhysics(ep_contact_get_point1_normalforce, "ep_contact_get_point1_normalforce");
	load_from_ExtremePhysics(ep_contact_get_point1_tangentforce, "ep_contact_get_point1_tangentforce");
	load_from_ExtremePhysics(ep_contact_get_point2_normalforce, "ep_contact_get_point2_normalforce");
	load_from_ExtremePhysics(ep_contact_get_point2_tangentforce, "ep_contact_get_point2_tangentforce");
	load_from_ExtremePhysics(ep_contact_get_point1_normalveldelta, "ep_contact_get_point1_normalveldelta");
	load_from_ExtremePhysics(ep_contact_get_point1_tangentveldelta, "ep_contact_get_point1_tangentveldelta");
	load_from_ExtremePhysics(ep_contact_get_point2_normalveldelta, "ep_contact_get_point2_normalveldelta");
	load_from_ExtremePhysics(ep_contact_get_point2_tangentveldelta, "ep_contact_get_point2_tangentveldelta");
	load_from_ExtremePhysics(ep_contact_previous, "ep_contact_previous");
	load_from_ExtremePhysics(ep_contact_next, "ep_contact_next");
	load_from_ExtremePhysics(ep_hingejoint_create, "ep_hingejoint_create");
	load_from_ExtremePhysics(ep_hingejoint_destroy, "ep_hingejoint_destroy");
	load_from_ExtremePhysics(ep_hingejoint_exists, "ep_hingejoint_exists");
	load_from_ExtremePhysics(ep_hingejoint_set_max_force, "ep_hingejoint_set_max_force");
	load_from_ExtremePhysics(ep_hingejoint_set_motor, "ep_hingejoint_set_motor");
	load_from_ExtremePhysics(ep_hingejoint_set_limit_settings, "ep_hingejoint_set_limit_settings");
	load_from_ExtremePhysics(ep_hingejoint_set_lower_limit, "ep_hingejoint_set_lower_limit");
	load_from_ExtremePhysics(ep_hingejoint_set_upper_limit, "ep_hingejoint_set_upper_limit");
	load_from_ExtremePhysics(ep_hingejoint_set_lower_spring, "ep_hingejoint_set_lower_spring");
	load_from_ExtremePhysics(ep_hingejoint_set_upper_spring, "ep_hingejoint_set_upper_spring");
	load_from_ExtremePhysics(ep_hingejoint_get_body1, "ep_hingejoint_get_body1");
	load_from_ExtremePhysics(ep_hingejoint_get_body2, "ep_hingejoint_get_body2");
	load_from_ExtremePhysics(ep_hingejoint_get_rotation, "ep_hingejoint_get_rotation");
	load_from_ExtremePhysics(ep_hingejoint_get_xforce, "ep_hingejoint_get_xforce");
	load_from_ExtremePhysics(ep_hingejoint_get_yforce, "ep_hingejoint_get_yforce");
	load_from_ExtremePhysics(ep_hingejoint_get_motor_torque, "ep_hingejoint_get_motor_torque");
	load_from_ExtremePhysics(ep_hingejoint_get_limit_torque, "ep_hingejoint_get_limit_torque");
	load_from_ExtremePhysics(ep_hingejoint_previous, "ep_hingejoint_previous");
	load_from_ExtremePhysics(ep_hingejoint_next, "ep_hingejoint_next");
	load_from_ExtremePhysics(ep_hingejoint_set_uservar, "ep_hingejoint_set_uservar");
	load_from_ExtremePhysics(ep_hingejoint_get_uservar, "ep_hingejoint_get_uservar");
	load_from_ExtremePhysics(ep_distancejoint_create, "ep_distancejoint_create");
	load_from_ExtremePhysics(ep_distancejoint_destroy, "ep_distancejoint_destroy");
	load_from_ExtremePhysics(ep_distancejoint_exists, "ep_distancejoint_exists");
	load_from_ExtremePhysics(ep_distancejoint_set_motor, "ep_distancejoint_set_motor");
	load_from_ExtremePhysics(ep_distancejoint_set_limit_settings, "ep_distancejoint_set_limit_settings");
	load_from_ExtremePhysics(ep_distancejoint_set_lower_limit, "ep_distancejoint_set_lower_limit");
	load_from_ExtremePhysics(ep_distancejoint_set_upper_limit, "ep_distancejoint_set_upper_limit");
	load_from_ExtremePhysics(ep_distancejoint_set_lower_spring, "ep_distancejoint_set_lower_spring");
	load_from_ExtremePhysics(ep_distancejoint_set_upper_spring, "ep_distancejoint_set_upper_spring");
	load_from_ExtremePhysics(ep_distancejoint_get_body1, "ep_distancejoint_get_body1");
	load_from_ExtremePhysics(ep_distancejoint_get_body2, "ep_distancejoint_get_body2");
	load_from_ExtremePhysics(ep_distancejoint_get_distance, "ep_distancejoint_get_distance");
	load_from_ExtremePhysics(ep_distancejoint_get_motor_force, "ep_distancejoint_get_motor_force");
	load_from_ExtremePhysics(ep_distancejoint_get_limit_force, "ep_distancejoint_get_limit_force");
	load_from_ExtremePhysics(ep_distancejoint_previous, "ep_distancejoint_previous");
	load_from_ExtremePhysics(ep_distancejoint_next, "ep_distancejoint_next");
	load_from_ExtremePhysics(ep_distancejoint_set_uservar, "ep_distancejoint_set_uservar");
	load_from_ExtremePhysics(ep_distancejoint_get_uservar, "ep_distancejoint_get_uservar");
	load_from_ExtremePhysics(ep_railjoint_create, "ep_railjoint_create");
	load_from_ExtremePhysics(ep_railjoint_destroy, "ep_railjoint_destroy");
	load_from_ExtremePhysics(ep_railjoint_exists, "ep_railjoint_exists");
	load_from_ExtremePhysics(ep_railjoint_set_max_normal_force, "ep_railjoint_set_max_normal_force");
	load_from_ExtremePhysics(ep_railjoint_set_motor, "ep_railjoint_set_motor");
	load_from_ExtremePhysics(ep_railjoint_set_limit_settings, "ep_railjoint_set_limit_settings");
	load_from_ExtremePhysics(ep_railjoint_set_lower_limit, "ep_railjoint_set_lower_limit");
	load_from_ExtremePhysics(ep_railjoint_set_upper_limit, "ep_railjoint_set_upper_limit");
	load_from_ExtremePhysics(ep_railjoint_set_lower_spring, "ep_railjoint_set_lower_spring");
	load_from_ExtremePhysics(ep_railjoint_set_upper_spring, "ep_railjoint_set_upper_spring");
	load_from_ExtremePhysics(ep_railjoint_get_body1, "ep_railjoint_get_body1");
	load_from_ExtremePhysics(ep_railjoint_get_body2, "ep_railjoint_get_body2");
	load_from_ExtremePhysics(ep_railjoint_get_position, "ep_railjoint_get_position");
	load_from_ExtremePhysics(ep_railjoint_get_normal_force, "ep_railjoint_get_normal_force");
	load_from_ExtremePhysics(ep_railjoint_get_motor_force, "ep_railjoint_get_motor_force");
	load_from_ExtremePhysics(ep_railjoint_get_limit_force, "ep_railjoint_get_limit_force");
	load_from_ExtremePhysics(ep_railjoint_previous, "ep_railjoint_previous");
	load_from_ExtremePhysics(ep_railjoint_next, "ep_railjoint_next");
	load_from_ExtremePhysics(ep_railjoint_set_uservar, "ep_railjoint_set_uservar");
	load_from_ExtremePhysics(ep_railjoint_get_uservar, "ep_railjoint_get_uservar");
	load_from_ExtremePhysics(ep_sliderjoint_create, "ep_sliderjoint_create");
	load_from_ExtremePhysics(ep_sliderjoint_destroy, "ep_sliderjoint_destroy");
	load_from_ExtremePhysics(ep_sliderjoint_exists, "ep_sliderjoint_exists");
	load_from_ExtremePhysics(ep_sliderjoint_set_max_combined_force, "ep_sliderjoint_set_max_combined_force");
	load_from_ExtremePhysics(ep_sliderjoint_set_motor, "ep_sliderjoint_set_motor");
	load_from_ExtremePhysics(ep_sliderjoint_set_limit_settings, "ep_sliderjoint_set_limit_settings");
	load_from_ExtremePhysics(ep_sliderjoint_set_lower_limit, "ep_sliderjoint_set_lower_limit");
	load_from_ExtremePhysics(ep_sliderjoint_set_upper_limit, "ep_sliderjoint_set_upper_limit");
	load_from_ExtremePhysics(ep_sliderjoint_set_lower_spring, "ep_sliderjoint_set_lower_spring");
	load_from_ExtremePhysics(ep_sliderjoint_set_upper_spring, "ep_sliderjoint_set_upper_spring");
	load_from_ExtremePhysics(ep_sliderjoint_get_body1, "ep_sliderjoint_get_body1");
	load_from_ExtremePhysics(ep_sliderjoint_get_body2, "ep_sliderjoint_get_body2");
	load_from_ExtremePhysics(ep_sliderjoint_get_position, "ep_sliderjoint_get_position");
	load_from_ExtremePhysics(ep_sliderjoint_get_normal_force, "ep_sliderjoint_get_normal_force");
	load_from_ExtremePhysics(ep_sliderjoint_get_torque, "ep_sliderjoint_get_torque");
	load_from_ExtremePhysics(ep_sliderjoint_get_combined_force, "ep_sliderjoint_get_combined_force");
	load_from_ExtremePhysics(ep_sliderjoint_get_motor_force, "ep_sliderjoint_get_motor_force");
	load_from_ExtremePhysics(ep_sliderjoint_get_limit_force, "ep_sliderjoint_get_limit_force");
	load_from_ExtremePhysics(ep_sliderjoint_previous, "ep_sliderjoint_previous");
	load_from_ExtremePhysics(ep_sliderjoint_next, "ep_sliderjoint_next");
	load_from_ExtremePhysics(ep_sliderjoint_set_uservar, "ep_sliderjoint_set_uservar");
	load_from_ExtremePhysics(ep_sliderjoint_get_uservar, "ep_sliderjoint_get_uservar");
	load_from_ExtremePhysics(ep_view_create, "ep_view_create");
	load_from_ExtremePhysics(ep_view_destroy, "ep_view_destroy");
	load_from_ExtremePhysics(ep_view_exists, "ep_view_exists");
	load_from_ExtremePhysics(ep_view_set_rectangle, "ep_view_set_rectangle");
	load_from_ExtremePhysics(ep_view_previous, "ep_view_previous");
	load_from_ExtremePhysics(ep_view_next, "ep_view_next");
	load_from_ExtremePhysics(ep_view_set_uservar, "ep_view_set_uservar");
	load_from_ExtremePhysics(ep_view_get_uservar, "ep_view_get_uservar");
	load_from_ExtremePhysics(ep_water_create, "ep_water_create");
	load_from_ExtremePhysics(ep_water_destroy, "ep_water_destroy");
	load_from_ExtremePhysics(ep_water_exists, "ep_water_exists");
	load_from_ExtremePhysics(ep_water_set_parameters, "ep_water_set_parameters");
	load_from_ExtremePhysics(ep_water_set_rectangle, "ep_water_set_rectangle");
	load_from_ExtremePhysics(ep_water_previous, "ep_water_previous");
	load_from_ExtremePhysics(ep_water_next, "ep_water_next");
	load_from_ExtremePhysics(ep_water_set_uservar, "ep_water_set_uservar");
	load_from_ExtremePhysics(ep_water_get_uservar, "ep_water_get_uservar");
	load_from_ExtremePhysics(ep_shape_create_box, "ep_shape_create_box");
	load_from_ExtremePhysics(ep_shape_create_line, "ep_shape_create_line");
	load_from_ExtremePhysics(ep_shape_create_circle, "ep_shape_create_circle");
	load_from_ExtremePhysics(ep_shape_create_polygon, "ep_shape_create_polygon");
	load_from_ExtremePhysics(ep_shape_destroy, "ep_shape_destroy");
	load_from_ExtremePhysics(ep_shape_exists, "ep_shape_exists");
	load_from_ExtremePhysics(ep_shape_get_first_contact, "ep_shape_get_first_contact");
	load_from_ExtremePhysics(ep_shape_get_last_contact, "ep_shape_get_last_contact");
	load_from_ExtremePhysics(ep_shape_get_previous_contact, "ep_shape_get_previous_contact");
	load_from_ExtremePhysics(ep_shape_get_next_contact, "ep_shape_get_next_contact");
	load_from_ExtremePhysics(ep_shape_set_material, "ep_shape_set_material");
	load_from_ExtremePhysics(ep_shape_set_collision, "ep_shape_set_collision");
	load_from_ExtremePhysics(ep_shape_collision_test_box, "ep_shape_collision_test_box");
	load_from_ExtremePhysics(ep_shape_collision_test_line, "ep_shape_collision_test_line");
	load_from_ExtremePhysics(ep_shape_collision_test_circle, "ep_shape_collision_test_circle");
	load_from_ExtremePhysics(ep_shape_collision_test_polygon, "ep_shape_collision_test_polygon");
	load_from_ExtremePhysics(ep_shape_ray_cast, "ep_shape_ray_cast");
	load_from_ExtremePhysics(ep_shape_previous, "ep_shape_previous");
	load_from_ExtremePhysics(ep_shape_next, "ep_shape_next");
	load_from_ExtremePhysics(ep_shape_set_uservar, "ep_shape_set_uservar");
	load_from_ExtremePhysics(ep_shape_get_uservar, "ep_shape_get_uservar");
	load_from_ExtremePhysics(ep_force_create, "ep_force_create");
	load_from_ExtremePhysics(ep_force_destroy, "ep_force_destroy");
	load_from_ExtremePhysics(ep_force_exists, "ep_force_exists");
	load_from_ExtremePhysics(ep_force_set_force, "ep_force_set_force");
	load_from_ExtremePhysics(ep_force_previous, "ep_force_previous");
	load_from_ExtremePhysics(ep_force_next, "ep_force_next");
	load_from_ExtremePhysics(ep_force_set_uservar, "ep_force_set_uservar");
	load_from_ExtremePhysics(ep_force_get_uservar, "ep_force_get_uservar");

	
}

const char* (*ep_version)();
double (*ep_set_log_file)(double enable, const char* filename, double level);
double (*ep_set_show_errors)(double enable);
double (*ep_message)(double level, const char* string);
double (*ep_print_object_tree)();
double (*ep_collision_test_box_box)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_w, double shape2_h, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
double (*ep_collision_test_box_line)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_x1, double shape2_y1, double shape2_x2, double shape2_y2, double contact_threshold);
double (*ep_collision_test_box_circle)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
double (*ep_collision_test_box_polygon)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
double (*ep_collision_test_line_line)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_x1, double shape2_y1, double shape2_x2, double shape2_y2, double contact_threshold);
double (*ep_collision_test_line_circle)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
double (*ep_collision_test_line_polygon)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
double (*ep_collision_test_circle_circle)(double shape1_r, double shape1_x, double shape1_y, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
double (*ep_collision_test_circle_polygon)(double shape1_r, double shape1_x, double shape1_y, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
double (*ep_collision_test_polygon_polygon)(double shape1_world_id, double shape1_polygon_id, double shape1_x, double shape1_y, double shape1_rot, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
double (*ep_ray_cast_box)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_w, double shape_h, double shape_x, double shape_y, double shape_rot);
double (*ep_ray_cast_line)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_x1, double shape_y1, double shape_x2, double shape_y2);
double (*ep_ray_cast_circle)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_r, double shape_x, double shape_y);
double (*ep_ray_cast_polygon)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_world_id, double shape_polygon_id, double shape_x, double shape_y, double shape_rot);
double (*ep_first_world)();
double (*ep_last_world)();
double (*ep_gm_functions_init)();
double (*ep_gm_functions_init_address)(double address);
double (*ep_debugdraw_set_transformation)(double translation_x, double translation_y, double rotation, double scale);
double (*ep_debugdraw_bodies)(double world_id, double color_static, double color_dynamic);
double (*ep_debugdraw_links)(double world_id, double color_shapelink, double color_contactlink, double color_jointlink);
double (*ep_debugdraw_views)(double world_id, double color_view);
double (*ep_debugdraw_velocity)(double world_id, double color_velocity, double scale, double rotscale);
double (*ep_debugdraw_forces)(double world_id, double color_force, double scale, double rotscale);
double (*ep_debugdraw_constraints)(double world_id, double color_contactpoint, double color_joint);
double (*ep_world_create)();
double (*ep_world_destroy)(double world_id);
double (*ep_world_exists)(double world_id);
double (*ep_world_clear)(double world_id);
double (*ep_world_set_settings)(double world_id, double timestep, double velocity_iterations, double position_iterations, double contact_threshold, double velocity_threshold, double baumgarte_factor, double mass_bias, double position_factor);
double (*ep_world_set_primary_axis)(double world_id, double horizontal);
double (*ep_world_set_sleeping)(double world_id, double enable_sleeping, double time_stable, double time_outofview, double stable_maxvel, double stable_maxrotvel);
double (*ep_world_update_contacts)(double world_id);
double (*ep_world_simulate_step)(double world_id);
double (*ep_world_collision_test_box)(double world_id, double w, double h, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_world_collision_test_line)(double world_id, double x1, double y1, double x2, double y2, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_world_collision_test_circle)(double world_id, double r, double x, double y, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_world_collision_test_polygon)(double world_id, double polygon_id, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_world_ray_cast)(double world_id, double x, double y, double vx, double vy, double collidemask1, double collidemask2, double group);
double (*ep_world_get_collision_body)(double world_id, double index);
double (*ep_world_get_collision_shape)(double world_id, double index);
double (*ep_world_multipoly_begin)(double world_id, double vertexcount);
double (*ep_world_multipoly_end)(double world_id, double showerrors);
double (*ep_world_multipoly_set_vertex)(double world_id, double index, double x, double y);
double (*ep_world_multipoly_get_first)(double world_id);
double (*ep_world_multipoly_get_last)(double world_id);
const char* (*ep_world_serialize)(double world_id);
double (*ep_world_unserialize)(double world_id, const char* data);
double (*ep_world_previous)(double world_id);
double (*ep_world_next)(double world_id);
double (*ep_world_set_uservar)(double world_id, double index, double value);
double (*ep_world_get_uservar)(double world_id, double body_id, double index);
double (*ep_world_first_polygon)(double world_id);
double (*ep_world_last_polygon)(double world_id);
double (*ep_world_polygon_count)(double world_id);
double (*ep_world_first_body)(double world_id);
double (*ep_world_last_body)(double world_id);
double (*ep_world_body_count)(double world_id);
double (*ep_world_first_contact)(double world_id);
double (*ep_world_last_contact)(double world_id);
double (*ep_world_contact_count)(double world_id);
double (*ep_world_first_hingejoint)(double world_id);
double (*ep_world_last_hingejoint)(double world_id);
double (*ep_world_hingejoint_count)(double world_id);
double (*ep_world_first_distancejoint)(double world_id);
double (*ep_world_last_distancejoint)(double world_id);
double (*ep_world_distancejoint_count)(double world_id);
double (*ep_world_first_railjoint)(double world_id);
double (*ep_world_last_railjoint)(double world_id);
double (*ep_world_railjoint_count)(double world_id);
double (*ep_world_first_sliderjoint)(double world_id);
double (*ep_world_last_sliderjoint)(double world_id);
double (*ep_world_sliderjoint_count)(double world_id);
double (*ep_world_first_view)(double world_id);
double (*ep_world_last_view)(double world_id);
double (*ep_world_view_count)(double world_id);
double (*ep_world_first_water)(double world_id);
double (*ep_world_last_water)(double world_id);
double (*ep_world_water_count)(double world_id);
double (*ep_world_shape_count)(double world_id);
double (*ep_world_force_count)(double world_id);
double (*ep_polygon_create)(double world_id, double vertex_count);
double (*ep_polygon_destroy)(double world_id, double polygon_id);
double (*ep_polygon_exists)(double world_id, double polygon_id);
double (*ep_polygon_set_vertex)(double world_id, double polygon_id, double index, double x, double y);
double (*ep_polygon_initialize)(double world_id, double polygon_id);
double (*ep_polygon_get_vertex_count)(double world_id, double polygon_id);
double (*ep_polygon_get_vertex_x)(double world_id, double polygon_id, double index);
double (*ep_polygon_get_vertex_y)(double world_id, double polygon_id, double index);
double (*ep_polygon_get_vertex_normal_x)(double world_id, double polygon_id, double index);
double (*ep_polygon_get_vertex_normal_y)(double world_id, double polygon_id, double index);
double (*ep_polygon_get_edge_length)(double world_id, double polygon_id, double index);
double (*ep_polygon_previous)(double world_id, double polygon_id);
double (*ep_polygon_next)(double world_id, double polygon_id);
double (*ep_polygon_set_uservar)(double world_id, double polygon_id, double index, double value);
double (*ep_polygon_get_uservar)(double world_id, double polygon_id, double index);
double (*ep_body_create_static)(double world_id);
double (*ep_body_create_dynamic)(double world_id, double norotation);
double (*ep_body_destroy)(double world_id, double body_id);
double (*ep_body_exists)(double world_id, double body_id);
double (*ep_body_get_first_hingejoint)(double world_id, double body_id);
double (*ep_body_get_last_hingejoint)(double world_id, double body_id);
double (*ep_body_get_previous_hingejoint)(double world_id, double body_id, double hingejoint_id);
double (*ep_body_get_next_hingejoint)(double world_id, double body_id, double hingejoint_id);
double (*ep_body_get_first_distancejoint)(double world_id, double body_id);
double (*ep_body_get_last_distancejoint)(double world_id, double body_id);
double (*ep_body_get_previous_distancejoint)(double world_id, double body_id, double distancejoint_id);
double (*ep_body_get_next_distancejoint)(double world_id, double body_id, double distancejoint_id);
double (*ep_body_get_first_railjoint)(double world_id, double body_id);
double (*ep_body_get_last_railjoint)(double world_id, double body_id);
double (*ep_body_get_previous_railjoint)(double world_id, double body_id, double railjoint_id);
double (*ep_body_get_next_railjoint)(double world_id, double body_id, double railjoint_id);
double (*ep_body_get_first_sliderjoint)(double world_id, double body_id);
double (*ep_body_get_last_sliderjoint)(double world_id, double body_id);
double (*ep_body_get_previous_sliderjoint)(double world_id, double body_id, double sliderjoint_id);
double (*ep_body_get_next_sliderjoint)(double world_id, double body_id, double sliderjoint_id);
double (*ep_body_calculate_mass)(double world_id, double body_id);
double (*ep_body_set_mass)(double world_id, double body_id, double mass);
double (*ep_body_set_inertia)(double world_id, double body_id, double inertia);
double (*ep_body_set_center)(double world_id, double body_id, double localx, double localy, double updateinertia);
double (*ep_body_set_position)(double world_id, double body_id, double x, double y, double rot);
double (*ep_body_set_position_center)(double world_id, double body_id, double x, double y, double rot);
double (*ep_body_set_position_local_point)(double world_id, double body_id, double x, double y, double rot, double localx, double localy);
double (*ep_body_set_velocity_center)(double world_id, double body_id, double xvel, double yvel, double rotvel);
double (*ep_body_set_velocity_local_point)(double world_id, double body_id, double xvel, double yvel, double rotvel, double localx, double localy);
double (*ep_body_set_max_velocity)(double world_id, double body_id, double maxvel, double maxrotvel);
double (*ep_body_set_gravity)(double world_id, double body_id, double gravity_x, double gravity_y);
double (*ep_body_set_damping)(double world_id, double body_id, double damping, double rotdamping);
double (*ep_body_store_impulses)(double world_id, double body_id, double storecontactimpulses, double storejointimpulses);
double (*ep_body_set_sleeping)(double world_id, double body_id, double sleepstable, double sleepoutofview);
double (*ep_body_collision_test_box)(double world_id, double body_id, double w, double h, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_body_collision_test_line)(double world_id, double body_id, double x1, double y1, double x2, double y2, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_body_collision_test_circle)(double world_id, double body_id, double r, double x, double y, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_body_collision_test_polygon)(double world_id, double body_id, double polygon_id, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
double (*ep_body_ray_cast)(double world_id, double body_id, double x, double y, double vx, double vy, double collidemask1, double collidemask2, double group);
double (*ep_body_apply_impulse)(double world_id, double body_id, double localx, double localy, double xforce, double yforce, double torque, double local, double ignoremass, double awake);
double (*ep_body_apply_impulse_relative)(double world_id, double body_id, double relativex, double relativey, double xforce, double yforce, double torque, double ignoremass, double awake);
double (*ep_body_get_mass)(double world_id, double body_id);
double (*ep_body_get_inertia)(double world_id, double body_id);
double (*ep_body_get_center_of_mass_x)(double world_id, double body_id);
double (*ep_body_get_center_of_mass_y)(double world_id, double body_id);
double (*ep_body_get_x)(double world_id, double body_id);
double (*ep_body_get_y)(double world_id, double body_id);
double (*ep_body_get_x_center)(double world_id, double body_id);
double (*ep_body_get_y_center)(double world_id, double body_id);
double (*ep_body_get_rot)(double world_id, double body_id);
double (*ep_body_get_xvel_center)(double world_id, double body_id);
double (*ep_body_get_yvel_center)(double world_id, double body_id);
double (*ep_body_get_xvel_local_point)(double world_id, double body_id, double localx, double localy);
double (*ep_body_get_yvel_local_point)(double world_id, double body_id, double localx, double localy);
double (*ep_body_get_rotvel)(double world_id, double body_id);
double (*ep_body_is_static)(double world_id, double body_id);
double (*ep_body_is_norotation)(double world_id, double body_id);
double (*ep_body_is_sleeping)(double world_id, double body_id);
double (*ep_body_stable_timer)(double world_id, double body_id);
double (*ep_body_out_of_view_timer)(double world_id, double body_id);
double (*ep_body_coord_local_to_world_x)(double world_id, double body_id, double localx, double localy);
double (*ep_body_coord_local_to_world_y)(double world_id, double body_id, double localx, double localy);
double (*ep_body_coord_world_to_local_x)(double world_id, double body_id, double worldx, double worldy);
double (*ep_body_coord_world_to_local_y)(double world_id, double body_id, double worldx, double worldy);
double (*ep_body_vect_local_to_world_x)(double world_id, double body_id, double vx, double vy);
double (*ep_body_vect_local_to_world_y)(double world_id, double body_id, double vx, double vy);
double (*ep_body_vect_world_to_local_x)(double world_id, double body_id, double vx, double vy);
double (*ep_body_vect_world_to_local_y)(double world_id, double body_id, double vx, double vy);
double (*ep_body_boxchain_begin)(double world_id, double body_id, double vertexcount);
double (*ep_body_boxchain_end)(double world_id, double body_id, double circular, double ignorefirstlast, double width_top, double width_bottom, double density);
double (*ep_body_boxchain_set_vertex)(double world_id, double body_id, double index, double x, double y);
double (*ep_body_boxchain_get_first)(double world_id, double body_id);
double (*ep_body_boxchain_get_last)(double world_id, double body_id);
double (*ep_body_previous)(double world_id, double body_id);
double (*ep_body_next)(double world_id, double body_id);
double (*ep_body_set_uservar)(double world_id, double body_id, double index, double value);
double (*ep_body_get_uservar)(double world_id, double body_id, double index);
double (*ep_body_first_shape)(double world_id, double body_id);
double (*ep_body_last_shape)(double world_id, double body_id);
double (*ep_body_shape_count)(double world_id, double body_id);
double (*ep_body_first_force)(double world_id, double body_id);
double (*ep_body_last_force)(double world_id, double body_id);
double (*ep_body_force_count)(double world_id, double body_id);
double (*ep_contact_destroy)(double world_id, double contact_id);
double (*ep_contact_exists)(double world_id, double contact_id);
double (*ep_contact_get_body1)(double world_id, double contact_id);
double (*ep_contact_get_body2)(double world_id, double contact_id);
double (*ep_contact_get_shape1)(double world_id, double contact_id);
double (*ep_contact_get_shape2)(double world_id, double contact_id);
double (*ep_contact_get_normal_x)(double world_id, double contact_id);
double (*ep_contact_get_normal_y)(double world_id, double contact_id);
double (*ep_contact_get_point1_active)(double world_id, double contact_id);
double (*ep_contact_get_point2_active)(double world_id, double contact_id);
double (*ep_contact_get_point1_x)(double world_id, double contact_id);
double (*ep_contact_get_point1_y)(double world_id, double contact_id);
double (*ep_contact_get_point2_x)(double world_id, double contact_id);
double (*ep_contact_get_point2_y)(double world_id, double contact_id);
double (*ep_contact_get_point1_separation)(double world_id, double contact_id);
double (*ep_contact_get_point2_separation)(double world_id, double contact_id);
double (*ep_contact_get_point1_normalforce)(double world_id, double contact_id);
double (*ep_contact_get_point1_tangentforce)(double world_id, double contact_id);
double (*ep_contact_get_point2_normalforce)(double world_id, double contact_id);
double (*ep_contact_get_point2_tangentforce)(double world_id, double contact_id);
double (*ep_contact_get_point1_normalveldelta)(double world_id, double contact_id);
double (*ep_contact_get_point1_tangentveldelta)(double world_id, double contact_id);
double (*ep_contact_get_point2_normalveldelta)(double world_id, double contact_id);
double (*ep_contact_get_point2_tangentveldelta)(double world_id, double contact_id);
double (*ep_contact_previous)(double world_id, double contact_id);
double (*ep_contact_next)(double world_id, double contact_id);
double (*ep_hingejoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2, double y2, double referencerotation);
double (*ep_hingejoint_destroy)(double world_id, double hingejoint_id);
double (*ep_hingejoint_exists)(double world_id, double hingejoint_id);
double (*ep_hingejoint_set_max_force)(double world_id, double hingejoint_id, double maxforce);
double (*ep_hingejoint_set_motor)(double world_id, double hingejoint_id, double maxmotortorque, double motorvel);
double (*ep_hingejoint_set_limit_settings)(double world_id, double hingejoint_id, double contact_threshold, double velocity_threshold);
double (*ep_hingejoint_set_lower_limit)(double world_id, double hingejoint_id, double maxlimittorque, double rotation, double restitution, double velocity);
double (*ep_hingejoint_set_upper_limit)(double world_id, double hingejoint_id, double maxlimittorque, double rotation, double restitution, double velocity);
double (*ep_hingejoint_set_lower_spring)(double world_id, double hingejoint_id, double k, double rotation, double damping);
double (*ep_hingejoint_set_upper_spring)(double world_id, double hingejoint_id, double k, double rotation, double damping);
double (*ep_hingejoint_get_body1)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_body2)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_rotation)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_xforce)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_yforce)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_motor_torque)(double world_id, double hingejoint_id);
double (*ep_hingejoint_get_limit_torque)(double world_id, double hingejoint_id);
double (*ep_hingejoint_previous)(double world_id, double hingejoint_id);
double (*ep_hingejoint_next)(double world_id, double hingejoint_id);
double (*ep_hingejoint_set_uservar)(double world_id, double hingejoint_id, double index, double value);
double (*ep_hingejoint_get_uservar)(double world_id, double hingejoint_id, double index);
double (*ep_distancejoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2, double y2);
double (*ep_distancejoint_destroy)(double world_id, double distancejoint_id);
double (*ep_distancejoint_exists)(double world_id, double distancejoint_id);
double (*ep_distancejoint_set_motor)(double world_id, double distancejoint_id, double maxmotorforce, double motorvel);
double (*ep_distancejoint_set_limit_settings)(double world_id, double distancejoint_id, double contact_threshold, double velocity_threshold);
double (*ep_distancejoint_set_lower_limit)(double world_id, double distancejoint_id, double maxlimitforce, double distance, double restitution, double velocity);
double (*ep_distancejoint_set_upper_limit)(double world_id, double distancejoint_id, double maxlimitforce, double distance, double restitution, double velocity);
double (*ep_distancejoint_set_lower_spring)(double world_id, double distancejoint_id, double k, double distance, double damping);
double (*ep_distancejoint_set_upper_spring)(double world_id, double distancejoint_id, double k, double distance, double damping);
double (*ep_distancejoint_get_body1)(double world_id, double distancejoint_id);
double (*ep_distancejoint_get_body2)(double world_id, double distancejoint_id);
double (*ep_distancejoint_get_distance)(double world_id, double distancejoint_id);
double (*ep_distancejoint_get_motor_force)(double world_id, double distancejoint_id);
double (*ep_distancejoint_get_limit_force)(double world_id, double distancejoint_id);
double (*ep_distancejoint_previous)(double world_id, double distancejoint_id);
double (*ep_distancejoint_next)(double world_id, double distancejoint_id);
double (*ep_distancejoint_set_uservar)(double world_id, double distancejoint_id, double index, double value);
double (*ep_distancejoint_get_uservar)(double world_id, double distancejoint_id, double index);
double (*ep_railjoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2a, double y2a, double x2b, double y2b);
double (*ep_railjoint_destroy)(double world_id, double railjoint_id);
double (*ep_railjoint_exists)(double world_id, double railjoint_id);
double (*ep_railjoint_set_max_normal_force)(double world_id, double railjoint_id, double maxnormalforce);
double (*ep_railjoint_set_motor)(double world_id, double railjoint_id, double maxmotorforce, double motorvel);
double (*ep_railjoint_set_limit_settings)(double world_id, double railjoint_id, double contact_threshold, double velocity_threshold);
double (*ep_railjoint_set_lower_limit)(double world_id, double railjoint_id, double maxlimitforce, double position, double restitution, double velocity);
double (*ep_railjoint_set_upper_limit)(double world_id, double railjoint_id, double maxlimitforce, double position, double restitution, double velocity);
double (*ep_railjoint_set_lower_spring)(double world_id, double railjoint_id, double k, double position, double damping);
double (*ep_railjoint_set_upper_spring)(double world_id, double railjoint_id, double k, double position, double damping);
double (*ep_railjoint_get_body1)(double world_id, double railjoint_id);
double (*ep_railjoint_get_body2)(double world_id, double railjoint_id);
double (*ep_railjoint_get_position)(double world_id, double railjoint_id);
double (*ep_railjoint_get_normal_force)(double world_id, double railjoint_id);
double (*ep_railjoint_get_motor_force)(double world_id, double railjoint_id);
double (*ep_railjoint_get_limit_force)(double world_id, double railjoint_id);
double (*ep_railjoint_previous)(double world_id, double railjoint_id);
double (*ep_railjoint_next)(double world_id, double railjoint_id);
double (*ep_railjoint_set_uservar)(double world_id, double railjoint_id, double index, double value);
double (*ep_railjoint_get_uservar)(double world_id, double railjoint_id, double index);
double (*ep_sliderjoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2a, double y2a, double x2b, double y2b, double rotation);
double (*ep_sliderjoint_destroy)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_exists)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_set_max_combined_force)(double world_id, double sliderjoint_id, double maxnormalforce, double torqueradius);
double (*ep_sliderjoint_set_motor)(double world_id, double sliderjoint_id, double maxmotorforce, double motorvel);
double (*ep_sliderjoint_set_limit_settings)(double world_id, double sliderjoint_id, double contact_threshold, double velocity_threshold);
double (*ep_sliderjoint_set_lower_limit)(double world_id, double sliderjoint_id, double maxlimitforce, double position, double restitution, double velocity);
double (*ep_sliderjoint_set_upper_limit)(double world_id, double sliderjoint_id, double maxlimitforce, double position, double restitution, double velocity);
double (*ep_sliderjoint_set_lower_spring)(double world_id, double sliderjoint_id, double k, double position, double damping);
double (*ep_sliderjoint_set_upper_spring)(double world_id, double sliderjoint_id, double k, double position, double damping);
double (*ep_sliderjoint_get_body1)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_body2)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_position)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_normal_force)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_torque)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_combined_force)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_motor_force)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_get_limit_force)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_previous)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_next)(double world_id, double sliderjoint_id);
double (*ep_sliderjoint_set_uservar)(double world_id, double sliderjoint_id, double index, double value);
double (*ep_sliderjoint_get_uservar)(double world_id, double sliderjoint_id, double index);
double (*ep_view_create)(double world_id);
double (*ep_view_destroy)(double world_id, double view_id);
double (*ep_view_exists)(double world_id, double view_id);
double (*ep_view_set_rectangle)(double world_id, double view_id, double x1, double y1, double x2, double y2);
double (*ep_view_previous)(double world_id, double view_id);
double (*ep_view_next)(double world_id, double view_id);
double (*ep_view_set_uservar)(double world_id, double view_id, double index, double value);
double (*ep_view_get_uservar)(double world_id, double view_id, double index);
double (*ep_water_create)(double world_id);
double (*ep_water_destroy)(double world_id, double water_id);
double (*ep_water_exists)(double world_id, double water_id);
double (*ep_water_set_parameters)(double world_id, double water_id, double density, double lineardrag, double quadraticdrag, double xvel, double yvel, double gravity_x, double gravity_y);
double (*ep_water_set_rectangle)(double world_id, double water_id, double x1, double y1, double x2, double y2);
double (*ep_water_previous)(double world_id, double water_id);
double (*ep_water_next)(double world_id, double water_id);
double (*ep_water_set_uservar)(double world_id, double water_id, double index, double value);
double (*ep_water_get_uservar)(double world_id, double water_id, double index);
double (*ep_shape_create_box)(double world_id, double body_id, double w, double h, double x, double y, double rot, double density);
double (*ep_shape_create_line)(double world_id, double body_id, double x1, double y1, double x2, double y2, double density);
double (*ep_shape_create_circle)(double world_id, double body_id, double r, double x, double y, double rot, double density);
double (*ep_shape_create_polygon)(double world_id, double body_id, double polygon_id, double x, double y, double rot, double density);
double (*ep_shape_destroy)(double world_id, double body_id, double shape_id);
double (*ep_shape_exists)(double world_id, double body_id, double shape_id);
double (*ep_shape_get_first_contact)(double world_id, double body_id, double shape_id);
double (*ep_shape_get_last_contact)(double world_id, double body_id, double shape_id);
double (*ep_shape_get_previous_contact)(double world_id, double body_id, double shape_id, double contact_id);
double (*ep_shape_get_next_contact)(double world_id, double body_id, double shape_id, double contact_id);
double (*ep_shape_set_material)(double world_id, double body_id, double shape_id, double restitution, double friction, double normalvelocity, double tangentvelocity);
double (*ep_shape_set_collision)(double world_id, double body_id, double shape_id, double collidemask1, double collidemask2, double group);
double (*ep_shape_collision_test_box)(double world_id, double body_id, double shape_id, double w, double h, double x, double y, double rot, double contact_threshold);
double (*ep_shape_collision_test_line)(double world_id, double body_id, double shape_id, double x1, double y1, double x2, double y2, double contact_threshold);
double (*ep_shape_collision_test_circle)(double world_id, double body_id, double shape_id, double r, double x, double y, double contact_threshold);
double (*ep_shape_collision_test_polygon)(double world_id, double body_id, double shape_id, double polygon_id, double x, double y, double rot, double contact_threshold);
double (*ep_shape_ray_cast)(double world_id, double body_id, double shape_id, double x, double y, double vx, double vy);
double (*ep_shape_previous)(double world_id, double body_id, double shape_id);
double (*ep_shape_next)(double world_id, double body_id, double shape_id);
double (*ep_shape_set_uservar)(double world_id, double body_id, double shape_id, double index, double value);
double (*ep_shape_get_uservar)(double world_id, double body_id, double shape_id, double index);
double (*ep_force_create)(double world_id, double body_id, double x, double y, double local, double ignoremass);
double (*ep_force_destroy)(double world_id, double body_id, double force_id);
double (*ep_force_exists)(double world_id, double body_id, double force_id);
double (*ep_force_set_force)(double world_id, double body_id, double force_id, double xforce, double yforce, double torque, double awake);
double (*ep_force_previous)(double world_id, double body_id, double force_id);
double (*ep_force_next)(double world_id, double body_id, double force_id);
double (*ep_force_set_uservar)(double world_id, double body_id, double force_id, double index, double value);
double (*ep_force_get_uservar)(double world_id, double body_id, double force_id, double index);


