#pragma once

void load_ExtremePhysics();

extern const char* (*ep_version)();
extern double (*ep_set_log_file)(double enable, const char* filename, double level);
extern double (*ep_set_show_errors)(double enable);
extern double (*ep_message)(double level, const char* string);
extern double (*ep_print_object_tree)();
extern double (*ep_collision_test_box_box)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_w, double shape2_h, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
extern double (*ep_collision_test_box_line)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_x1, double shape2_y1, double shape2_x2, double shape2_y2, double contact_threshold);
extern double (*ep_collision_test_box_circle)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
extern double (*ep_collision_test_box_polygon)(double shape1_w, double shape1_h, double shape1_x, double shape1_y, double shape1_rot, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
extern double (*ep_collision_test_line_line)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_x1, double shape2_y1, double shape2_x2, double shape2_y2, double contact_threshold);
extern double (*ep_collision_test_line_circle)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
extern double (*ep_collision_test_line_polygon)(double shape1_x1, double shape1_y1, double shape1_x2, double shape1_y2, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
extern double (*ep_collision_test_circle_circle)(double shape1_r, double shape1_x, double shape1_y, double shape2_r, double shape2_x, double shape2_y, double contact_threshold);
extern double (*ep_collision_test_circle_polygon)(double shape1_r, double shape1_x, double shape1_y, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
extern double (*ep_collision_test_polygon_polygon)(double shape1_world_id, double shape1_polygon_id, double shape1_x, double shape1_y, double shape1_rot, double shape2_world_id, double shape2_polygon_id, double shape2_x, double shape2_y, double shape2_rot, double contact_threshold);
extern double (*ep_ray_cast_box)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_w, double shape_h, double shape_x, double shape_y, double shape_rot);
extern double (*ep_ray_cast_line)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_x1, double shape_y1, double shape_x2, double shape_y2);
extern double (*ep_ray_cast_circle)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_r, double shape_x, double shape_y);
extern double (*ep_ray_cast_polygon)(double ray_x, double ray_y, double ray_vx, double ray_vy, double shape_world_id, double shape_polygon_id, double shape_x, double shape_y, double shape_rot);
extern double (*ep_first_world)();
extern double (*ep_last_world)();
extern double (*ep_gm_functions_init)();
extern double (*ep_gm_functions_init_address)(double address);
extern double (*ep_debugdraw_set_transformation)(double translation_x, double translation_y, double rotation, double scale);
extern double (*ep_debugdraw_bodies)(double world_id, double color_static, double color_dynamic);
extern double (*ep_debugdraw_links)(double world_id, double color_shapelink, double color_contactlink, double color_jointlink);
extern double (*ep_debugdraw_views)(double world_id, double color_view);
extern double (*ep_debugdraw_velocity)(double world_id, double color_velocity, double scale, double rotscale);
extern double (*ep_debugdraw_forces)(double world_id, double color_force, double scale, double rotscale);
extern double (*ep_debugdraw_constraints)(double world_id, double color_contactpoint, double color_joint);
extern double (*ep_world_create)();
extern double (*ep_world_destroy)(double world_id);
extern double (*ep_world_exists)(double world_id);
extern double (*ep_world_clear)(double world_id);
extern double (*ep_world_set_settings)(double world_id, double timestep, double velocity_iterations, double position_iterations, double contact_threshold, double velocity_threshold, double baumgarte_factor, double mass_bias, double position_factor);
extern double (*ep_world_set_primary_axis)(double world_id, double horizontal);
extern double (*ep_world_set_sleeping)(double world_id, double enable_sleeping, double time_stable, double time_outofview, double stable_maxvel, double stable_maxrotvel);
extern double (*ep_world_update_contacts)(double world_id);
extern double (*ep_world_simulate_step)(double world_id);
extern double (*ep_world_collision_test_box)(double world_id, double w, double h, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_world_collision_test_line)(double world_id, double x1, double y1, double x2, double y2, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_world_collision_test_circle)(double world_id, double r, double x, double y, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_world_collision_test_polygon)(double world_id, double polygon_id, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_world_ray_cast)(double world_id, double x, double y, double vx, double vy, double collidemask1, double collidemask2, double group);
extern double (*ep_world_get_collision_body)(double world_id, double index);
extern double (*ep_world_get_collision_shape)(double world_id, double index);
extern double (*ep_world_multipoly_begin)(double world_id, double vertexcount);
extern double (*ep_world_multipoly_end)(double world_id, double showerrors);
extern double (*ep_world_multipoly_set_vertex)(double world_id, double index, double x, double y);
extern double (*ep_world_multipoly_get_first)(double world_id);
extern double (*ep_world_multipoly_get_last)(double world_id);
extern const char* (*ep_world_serialize)(double world_id);
extern double (*ep_world_unserialize)(double world_id, const char* data);
extern double (*ep_world_previous)(double world_id);
extern double (*ep_world_next)(double world_id);
extern double (*ep_world_set_uservar)(double world_id, double index, double value);
extern double (*ep_world_get_uservar)(double world_id, double body_id, double index);
extern double (*ep_world_first_polygon)(double world_id);
extern double (*ep_world_last_polygon)(double world_id);
extern double (*ep_world_polygon_count)(double world_id);
extern double (*ep_world_first_body)(double world_id);
extern double (*ep_world_last_body)(double world_id);
extern double (*ep_world_body_count)(double world_id);
extern double (*ep_world_first_contact)(double world_id);
extern double (*ep_world_last_contact)(double world_id);
extern double (*ep_world_contact_count)(double world_id);
extern double (*ep_world_first_hingejoint)(double world_id);
extern double (*ep_world_last_hingejoint)(double world_id);
extern double (*ep_world_hingejoint_count)(double world_id);
extern double (*ep_world_first_distancejoint)(double world_id);
extern double (*ep_world_last_distancejoint)(double world_id);
extern double (*ep_world_distancejoint_count)(double world_id);
extern double (*ep_world_first_railjoint)(double world_id);
extern double (*ep_world_last_railjoint)(double world_id);
extern double (*ep_world_railjoint_count)(double world_id);
extern double (*ep_world_first_sliderjoint)(double world_id);
extern double (*ep_world_last_sliderjoint)(double world_id);
extern double (*ep_world_sliderjoint_count)(double world_id);
extern double (*ep_world_first_view)(double world_id);
extern double (*ep_world_last_view)(double world_id);
extern double (*ep_world_view_count)(double world_id);
extern double (*ep_world_first_water)(double world_id);
extern double (*ep_world_last_water)(double world_id);
extern double (*ep_world_water_count)(double world_id);
extern double (*ep_world_shape_count)(double world_id);
extern double (*ep_world_force_count)(double world_id);
extern double (*ep_polygon_create)(double world_id, double vertex_count);
extern double (*ep_polygon_destroy)(double world_id, double polygon_id);
extern double (*ep_polygon_exists)(double world_id, double polygon_id);
extern double (*ep_polygon_set_vertex)(double world_id, double polygon_id, double index, double x, double y);
extern double (*ep_polygon_initialize)(double world_id, double polygon_id);
extern double (*ep_polygon_get_vertex_count)(double world_id, double polygon_id);
extern double (*ep_polygon_get_vertex_x)(double world_id, double polygon_id, double index);
extern double (*ep_polygon_get_vertex_y)(double world_id, double polygon_id, double index);
extern double (*ep_polygon_get_vertex_normal_x)(double world_id, double polygon_id, double index);
extern double (*ep_polygon_get_vertex_normal_y)(double world_id, double polygon_id, double index);
extern double (*ep_polygon_get_edge_length)(double world_id, double polygon_id, double index);
extern double (*ep_polygon_previous)(double world_id, double polygon_id);
extern double (*ep_polygon_next)(double world_id, double polygon_id);
extern double (*ep_polygon_set_uservar)(double world_id, double polygon_id, double index, double value);
extern double (*ep_polygon_get_uservar)(double world_id, double polygon_id, double index);
extern double (*ep_body_create_static)(double world_id);
extern double (*ep_body_create_dynamic)(double world_id, double norotation);
extern double (*ep_body_destroy)(double world_id, double body_id);
extern double (*ep_body_exists)(double world_id, double body_id);
extern double (*ep_body_get_first_hingejoint)(double world_id, double body_id);
extern double (*ep_body_get_last_hingejoint)(double world_id, double body_id);
extern double (*ep_body_get_previous_hingejoint)(double world_id, double body_id, double hingejoint_id);
extern double (*ep_body_get_next_hingejoint)(double world_id, double body_id, double hingejoint_id);
extern double (*ep_body_get_first_distancejoint)(double world_id, double body_id);
extern double (*ep_body_get_last_distancejoint)(double world_id, double body_id);
extern double (*ep_body_get_previous_distancejoint)(double world_id, double body_id, double distancejoint_id);
extern double (*ep_body_get_next_distancejoint)(double world_id, double body_id, double distancejoint_id);
extern double (*ep_body_get_first_railjoint)(double world_id, double body_id);
extern double (*ep_body_get_last_railjoint)(double world_id, double body_id);
extern double (*ep_body_get_previous_railjoint)(double world_id, double body_id, double railjoint_id);
extern double (*ep_body_get_next_railjoint)(double world_id, double body_id, double railjoint_id);
extern double (*ep_body_get_first_sliderjoint)(double world_id, double body_id);
extern double (*ep_body_get_last_sliderjoint)(double world_id, double body_id);
extern double (*ep_body_get_previous_sliderjoint)(double world_id, double body_id, double sliderjoint_id);
extern double (*ep_body_get_next_sliderjoint)(double world_id, double body_id, double sliderjoint_id);
extern double (*ep_body_calculate_mass)(double world_id, double body_id);
extern double (*ep_body_set_mass)(double world_id, double body_id, double mass);
extern double (*ep_body_set_inertia)(double world_id, double body_id, double inertia);
extern double (*ep_body_set_center)(double world_id, double body_id, double localx, double localy, double updateinertia);
extern double (*ep_body_set_position)(double world_id, double body_id, double x, double y, double rot);
extern double (*ep_body_set_position_center)(double world_id, double body_id, double x, double y, double rot);
extern double (*ep_body_set_position_local_point)(double world_id, double body_id, double x, double y, double rot, double localx, double localy);
extern double (*ep_body_set_velocity_center)(double world_id, double body_id, double xvel, double yvel, double rotvel);
extern double (*ep_body_set_velocity_local_point)(double world_id, double body_id, double xvel, double yvel, double rotvel, double localx, double localy);
extern double (*ep_body_set_max_velocity)(double world_id, double body_id, double maxvel, double maxrotvel);
extern double (*ep_body_set_gravity)(double world_id, double body_id, double gravity_x, double gravity_y);
extern double (*ep_body_set_damping)(double world_id, double body_id, double damping, double rotdamping);
extern double (*ep_body_store_impulses)(double world_id, double body_id, double storecontactimpulses, double storejointimpulses);
extern double (*ep_body_set_sleeping)(double world_id, double body_id, double sleepstable, double sleepoutofview);
extern double (*ep_body_collision_test_box)(double world_id, double body_id, double w, double h, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_body_collision_test_line)(double world_id, double body_id, double x1, double y1, double x2, double y2, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_body_collision_test_circle)(double world_id, double body_id, double r, double x, double y, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_body_collision_test_polygon)(double world_id, double body_id, double polygon_id, double x, double y, double rot, double contact_threshold, double collidemask1, double collidemask2, double group);
extern double (*ep_body_ray_cast)(double world_id, double body_id, double x, double y, double vx, double vy, double collidemask1, double collidemask2, double group);
extern double (*ep_body_apply_impulse)(double world_id, double body_id, double localx, double localy, double xforce, double yforce, double torque, double local, double ignoremass, double awake);
extern double (*ep_body_apply_impulse_relative)(double world_id, double body_id, double relativex, double relativey, double xforce, double yforce, double torque, double ignoremass, double awake);
extern double (*ep_body_get_mass)(double world_id, double body_id);
extern double (*ep_body_get_inertia)(double world_id, double body_id);
extern double (*ep_body_get_center_of_mass_x)(double world_id, double body_id);
extern double (*ep_body_get_center_of_mass_y)(double world_id, double body_id);
extern double (*ep_body_get_x)(double world_id, double body_id);
extern double (*ep_body_get_y)(double world_id, double body_id);
extern double (*ep_body_get_x_center)(double world_id, double body_id);
extern double (*ep_body_get_y_center)(double world_id, double body_id);
extern double (*ep_body_get_rot)(double world_id, double body_id);
extern double (*ep_body_get_xvel_center)(double world_id, double body_id);
extern double (*ep_body_get_yvel_center)(double world_id, double body_id);
extern double (*ep_body_get_xvel_local_point)(double world_id, double body_id, double localx, double localy);
extern double (*ep_body_get_yvel_local_point)(double world_id, double body_id, double localx, double localy);
extern double (*ep_body_get_rotvel)(double world_id, double body_id);
extern double (*ep_body_is_static)(double world_id, double body_id);
extern double (*ep_body_is_norotation)(double world_id, double body_id);
extern double (*ep_body_is_sleeping)(double world_id, double body_id);
extern double (*ep_body_stable_timer)(double world_id, double body_id);
extern double (*ep_body_out_of_view_timer)(double world_id, double body_id);
extern double (*ep_body_coord_local_to_world_x)(double world_id, double body_id, double localx, double localy);
extern double (*ep_body_coord_local_to_world_y)(double world_id, double body_id, double localx, double localy);
extern double (*ep_body_coord_world_to_local_x)(double world_id, double body_id, double worldx, double worldy);
extern double (*ep_body_coord_world_to_local_y)(double world_id, double body_id, double worldx, double worldy);
extern double (*ep_body_vect_local_to_world_x)(double world_id, double body_id, double vx, double vy);
extern double (*ep_body_vect_local_to_world_y)(double world_id, double body_id, double vx, double vy);
extern double (*ep_body_vect_world_to_local_x)(double world_id, double body_id, double vx, double vy);
extern double (*ep_body_vect_world_to_local_y)(double world_id, double body_id, double vx, double vy);
extern double (*ep_body_boxchain_begin)(double world_id, double body_id, double vertexcount);
extern double (*ep_body_boxchain_end)(double world_id, double body_id, double circular, double ignorefirstlast, double width_top, double width_bottom, double density);
extern double (*ep_body_boxchain_set_vertex)(double world_id, double body_id, double index, double x, double y);
extern double (*ep_body_boxchain_get_first)(double world_id, double body_id);
extern double (*ep_body_boxchain_get_last)(double world_id, double body_id);
extern double (*ep_body_previous)(double world_id, double body_id);
extern double (*ep_body_next)(double world_id, double body_id);
extern double (*ep_body_set_uservar)(double world_id, double body_id, double index, double value);
extern double (*ep_body_get_uservar)(double world_id, double body_id, double index);
extern double (*ep_body_first_shape)(double world_id, double body_id);
extern double (*ep_body_last_shape)(double world_id, double body_id);
extern double (*ep_body_shape_count)(double world_id, double body_id);
extern double (*ep_body_first_force)(double world_id, double body_id);
extern double (*ep_body_last_force)(double world_id, double body_id);
extern double (*ep_body_force_count)(double world_id, double body_id);
extern double (*ep_contact_destroy)(double world_id, double contact_id);
extern double (*ep_contact_exists)(double world_id, double contact_id);
extern double (*ep_contact_get_body1)(double world_id, double contact_id);
extern double (*ep_contact_get_body2)(double world_id, double contact_id);
extern double (*ep_contact_get_shape1)(double world_id, double contact_id);
extern double (*ep_contact_get_shape2)(double world_id, double contact_id);
extern double (*ep_contact_get_normal_x)(double world_id, double contact_id);
extern double (*ep_contact_get_normal_y)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_active)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_active)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_x)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_y)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_x)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_y)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_separation)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_separation)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_normalforce)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_tangentforce)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_normalforce)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_tangentforce)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_normalveldelta)(double world_id, double contact_id);
extern double (*ep_contact_get_point1_tangentveldelta)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_normalveldelta)(double world_id, double contact_id);
extern double (*ep_contact_get_point2_tangentveldelta)(double world_id, double contact_id);
extern double (*ep_contact_previous)(double world_id, double contact_id);
extern double (*ep_contact_next)(double world_id, double contact_id);
extern double (*ep_hingejoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2, double y2, double referencerotation);
extern double (*ep_hingejoint_destroy)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_exists)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_set_max_force)(double world_id, double hingejoint_id, double maxforce);
extern double (*ep_hingejoint_set_motor)(double world_id, double hingejoint_id, double maxmotortorque, double motorvel);
extern double (*ep_hingejoint_set_limit_settings)(double world_id, double hingejoint_id, double contact_threshold, double velocity_threshold);
extern double (*ep_hingejoint_set_lower_limit)(double world_id, double hingejoint_id, double maxlimittorque, double rotation, double restitution, double velocity);
extern double (*ep_hingejoint_set_upper_limit)(double world_id, double hingejoint_id, double maxlimittorque, double rotation, double restitution, double velocity);
extern double (*ep_hingejoint_set_lower_spring)(double world_id, double hingejoint_id, double k, double rotation, double damping);
extern double (*ep_hingejoint_set_upper_spring)(double world_id, double hingejoint_id, double k, double rotation, double damping);
extern double (*ep_hingejoint_get_body1)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_body2)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_rotation)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_xforce)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_yforce)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_motor_torque)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_get_limit_torque)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_previous)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_next)(double world_id, double hingejoint_id);
extern double (*ep_hingejoint_set_uservar)(double world_id, double hingejoint_id, double index, double value);
extern double (*ep_hingejoint_get_uservar)(double world_id, double hingejoint_id, double index);
extern double (*ep_distancejoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2, double y2);
extern double (*ep_distancejoint_destroy)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_exists)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_set_motor)(double world_id, double distancejoint_id, double maxmotorforce, double motorvel);
extern double (*ep_distancejoint_set_limit_settings)(double world_id, double distancejoint_id, double contact_threshold, double velocity_threshold);
extern double (*ep_distancejoint_set_lower_limit)(double world_id, double distancejoint_id, double maxlimitforce, double distance, double restitution, double velocity);
extern double (*ep_distancejoint_set_upper_limit)(double world_id, double distancejoint_id, double maxlimitforce, double distance, double restitution, double velocity);
extern double (*ep_distancejoint_set_lower_spring)(double world_id, double distancejoint_id, double k, double distance, double damping);
extern double (*ep_distancejoint_set_upper_spring)(double world_id, double distancejoint_id, double k, double distance, double damping);
extern double (*ep_distancejoint_get_body1)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_get_body2)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_get_distance)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_get_motor_force)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_get_limit_force)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_previous)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_next)(double world_id, double distancejoint_id);
extern double (*ep_distancejoint_set_uservar)(double world_id, double distancejoint_id, double index, double value);
extern double (*ep_distancejoint_get_uservar)(double world_id, double distancejoint_id, double index);
extern double (*ep_railjoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2a, double y2a, double x2b, double y2b);
extern double (*ep_railjoint_destroy)(double world_id, double railjoint_id);
extern double (*ep_railjoint_exists)(double world_id, double railjoint_id);
extern double (*ep_railjoint_set_max_normal_force)(double world_id, double railjoint_id, double maxnormalforce);
extern double (*ep_railjoint_set_motor)(double world_id, double railjoint_id, double maxmotorforce, double motorvel);
extern double (*ep_railjoint_set_limit_settings)(double world_id, double railjoint_id, double contact_threshold, double velocity_threshold);
extern double (*ep_railjoint_set_lower_limit)(double world_id, double railjoint_id, double maxlimitforce, double position, double restitution, double velocity);
extern double (*ep_railjoint_set_upper_limit)(double world_id, double railjoint_id, double maxlimitforce, double position, double restitution, double velocity);
extern double (*ep_railjoint_set_lower_spring)(double world_id, double railjoint_id, double k, double position, double damping);
extern double (*ep_railjoint_set_upper_spring)(double world_id, double railjoint_id, double k, double position, double damping);
extern double (*ep_railjoint_get_body1)(double world_id, double railjoint_id);
extern double (*ep_railjoint_get_body2)(double world_id, double railjoint_id);
extern double (*ep_railjoint_get_position)(double world_id, double railjoint_id);
extern double (*ep_railjoint_get_normal_force)(double world_id, double railjoint_id);
extern double (*ep_railjoint_get_motor_force)(double world_id, double railjoint_id);
extern double (*ep_railjoint_get_limit_force)(double world_id, double railjoint_id);
extern double (*ep_railjoint_previous)(double world_id, double railjoint_id);
extern double (*ep_railjoint_next)(double world_id, double railjoint_id);
extern double (*ep_railjoint_set_uservar)(double world_id, double railjoint_id, double index, double value);
extern double (*ep_railjoint_get_uservar)(double world_id, double railjoint_id, double index);
extern double (*ep_sliderjoint_create)(double world_id, double body1_id, double body2_id, double x1, double y1, double x2a, double y2a, double x2b, double y2b, double rotation);
extern double (*ep_sliderjoint_destroy)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_exists)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_set_max_combined_force)(double world_id, double sliderjoint_id, double maxnormalforce, double torqueradius);
extern double (*ep_sliderjoint_set_motor)(double world_id, double sliderjoint_id, double maxmotorforce, double motorvel);
extern double (*ep_sliderjoint_set_limit_settings)(double world_id, double sliderjoint_id, double contact_threshold, double velocity_threshold);
extern double (*ep_sliderjoint_set_lower_limit)(double world_id, double sliderjoint_id, double maxlimitforce, double position, double restitution, double velocity);
extern double (*ep_sliderjoint_set_upper_limit)(double world_id, double sliderjoint_id, double maxlimitforce, double position, double restitution, double velocity);
extern double (*ep_sliderjoint_set_lower_spring)(double world_id, double sliderjoint_id, double k, double position, double damping);
extern double (*ep_sliderjoint_set_upper_spring)(double world_id, double sliderjoint_id, double k, double position, double damping);
extern double (*ep_sliderjoint_get_body1)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_body2)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_position)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_normal_force)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_torque)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_combined_force)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_motor_force)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_get_limit_force)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_previous)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_next)(double world_id, double sliderjoint_id);
extern double (*ep_sliderjoint_set_uservar)(double world_id, double sliderjoint_id, double index, double value);
extern double (*ep_sliderjoint_get_uservar)(double world_id, double sliderjoint_id, double index);
extern double (*ep_view_create)(double world_id);
extern double (*ep_view_destroy)(double world_id, double view_id);
extern double (*ep_view_exists)(double world_id, double view_id);
extern double (*ep_view_set_rectangle)(double world_id, double view_id, double x1, double y1, double x2, double y2);
extern double (*ep_view_previous)(double world_id, double view_id);
extern double (*ep_view_next)(double world_id, double view_id);
extern double (*ep_view_set_uservar)(double world_id, double view_id, double index, double value);
extern double (*ep_view_get_uservar)(double world_id, double view_id, double index);
extern double (*ep_water_create)(double world_id);
extern double (*ep_water_destroy)(double world_id, double water_id);
extern double (*ep_water_exists)(double world_id, double water_id);
extern double (*ep_water_set_parameters)(double world_id, double water_id, double density, double lineardrag, double quadraticdrag, double xvel, double yvel, double gravity_x, double gravity_y);
extern double (*ep_water_set_rectangle)(double world_id, double water_id, double x1, double y1, double x2, double y2);
extern double (*ep_water_previous)(double world_id, double water_id);
extern double (*ep_water_next)(double world_id, double water_id);
extern double (*ep_water_set_uservar)(double world_id, double water_id, double index, double value);
extern double (*ep_water_get_uservar)(double world_id, double water_id, double index);
extern double (*ep_shape_create_box)(double world_id, double body_id, double w, double h, double x, double y, double rot, double density);
extern double (*ep_shape_create_line)(double world_id, double body_id, double x1, double y1, double x2, double y2, double density);
extern double (*ep_shape_create_circle)(double world_id, double body_id, double r, double x, double y, double rot, double density);
extern double (*ep_shape_create_polygon)(double world_id, double body_id, double polygon_id, double x, double y, double rot, double density);
extern double (*ep_shape_destroy)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_exists)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_get_first_contact)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_get_last_contact)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_get_previous_contact)(double world_id, double body_id, double shape_id, double contact_id);
extern double (*ep_shape_get_next_contact)(double world_id, double body_id, double shape_id, double contact_id);
extern double (*ep_shape_set_material)(double world_id, double body_id, double shape_id, double restitution, double friction, double normalvelocity, double tangentvelocity);
extern double (*ep_shape_set_collision)(double world_id, double body_id, double shape_id, double collidemask1, double collidemask2, double group);
extern double (*ep_shape_collision_test_box)(double world_id, double body_id, double shape_id, double w, double h, double x, double y, double rot, double contact_threshold);
extern double (*ep_shape_collision_test_line)(double world_id, double body_id, double shape_id, double x1, double y1, double x2, double y2, double contact_threshold);
extern double (*ep_shape_collision_test_circle)(double world_id, double body_id, double shape_id, double r, double x, double y, double contact_threshold);
extern double (*ep_shape_collision_test_polygon)(double world_id, double body_id, double shape_id, double polygon_id, double x, double y, double rot, double contact_threshold);
extern double (*ep_shape_ray_cast)(double world_id, double body_id, double shape_id, double x, double y, double vx, double vy);
extern double (*ep_shape_previous)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_next)(double world_id, double body_id, double shape_id);
extern double (*ep_shape_set_uservar)(double world_id, double body_id, double shape_id, double index, double value);
extern double (*ep_shape_get_uservar)(double world_id, double body_id, double shape_id, double index);
extern double (*ep_force_create)(double world_id, double body_id, double x, double y, double local, double ignoremass);
extern double (*ep_force_destroy)(double world_id, double body_id, double force_id);
extern double (*ep_force_exists)(double world_id, double body_id, double force_id);
extern double (*ep_force_set_force)(double world_id, double body_id, double force_id, double xforce, double yforce, double torque, double awake);
extern double (*ep_force_previous)(double world_id, double body_id, double force_id);
extern double (*ep_force_next)(double world_id, double body_id, double force_id);
extern double (*ep_force_set_uservar)(double world_id, double body_id, double force_id, double index, double value);
extern double (*ep_force_get_uservar)(double world_id, double body_id, double force_id, double index);


